package com.ibm.ws390.samples.ivp.ejb;

import java.rmi.RemoteException;
import java.security.Identity;
import java.util.Properties;
import javax.ejb.*;
import java.sql.*;
import java.lang.*;
import javax.naming.InitialContext;
/**
 * This is an Entity Bean class with BMP fields
 */
public class PolicyBMPBean implements EntityBean {
	private javax.ejb.EntityContext entityContext = null;

	public int policyNo;
	public double premium;
	public double amount;

	java.sql.Connection conn = null;
	private javax.sql.DataSource ds = null;

	/**
	 * ejbActivate method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbActivate() throws java.rmi.RemoteException {
	}
	/**
	 * ejbCreate method for a BMP entity bean
	 * @return com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey
	 * @param int policyNo
	 * @exception javax.ejb.CreateException The exception description.
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey ejbCreate(int policyNo)
		throws javax.ejb.CreateException {
		PreparedStatement pstmt = null, pstmt1 = null;
		Connection conn = null;
		amount = 0;
		premium = 0;
		try {
			ResultSet rs = null;
			this.policyNo = policyNo;
			//
			// determine if key already exists 
			//
			conn = getConnection();
			pstmt = conn.prepareStatement("select * from BBO.POLICYDO where PNUMBER = ?");
			pstmt.setInt(1, policyNo);
			rs = pstmt.executeQuery();
			//
			// nope, go create it.
			// 
			if (!(rs.next())) {
				pstmt1 =
					conn.prepareStatement(
						"insert into BBO.POLICYDO (PNUMBER,PAMOUNT, PPREMIUM) values(?, ?, ?)");
				pstmt1.setInt(1, policyNo);
				pstmt1.setDouble(2, amount);
				pstmt1.setDouble(3, premium);
				pstmt1.executeUpdate();
				return new PolicyBMPKey(policyNo);

			}
			//
			// key already exists, throw and exception
			//
			else {
				throw new javax.ejb.DuplicateKeyException(
					"Key - " + ((new Integer(policyNo)).toString()));
			}
		} catch (java.sql.SQLException ex) {
			ex.printStackTrace();
			throw new javax.ejb.CreateException(
				"Key - " + ((new Integer(policyNo)).toString()) + "  " + ex.toString());
		} catch (javax.ejb.DuplicateKeyException ex) {
			throw ex;
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex.toString());
		}
		//
		// cleanup
		//
		finally {
			try {
				if (pstmt != null)
					pstmt.close();
			} catch (Exception e) {
			}
			try {
				if (conn != null)
					conn.close();
			} catch (Exception e) {
			}
		}
	}
	/**
	 * ejbCreate method for a BMP entity bean
	 * @return com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey
	 * @param key com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey
	 * @exception javax.ejb.CreateException The exception description.
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey ejbCreate(
		com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey key)
		throws javax.ejb.CreateException {
		policyNo = key.policyNo;
		PreparedStatement pstmt = null, pstmt1 = null;
		Connection conn = null;
		amount = 0;
		premium = 0;
		try {
			ResultSet rs = null;
			conn = getConnection();
			//
			// determine if key already exists
			//
			pstmt = conn.prepareStatement("select * from BBO.POLICYDO where PNUMBER = ?");
			pstmt.setInt(1, policyNo);
			rs = pstmt.executeQuery();
			//
			// not found, insert a new entry
			//
			if (!(rs.next())) {
				pstmt1 =
					conn.prepareStatement(
						"insert into BBO.POLICYDO (PNUMBER,PAMOUNT, PPREMIUM) values(?, ?, ?)");
				pstmt1.setInt(1, policyNo);
				pstmt1.setDouble(2, amount);
				pstmt1.setDouble(3, premium);
				pstmt1.executeUpdate();
				return new PolicyBMPKey(policyNo);

			}
			//
			// key already exists, throw exception
			else {
				throw new javax.ejb.DuplicateKeyException(
					"Key - " + ((new Integer(policyNo)).toString()));
			}
		} catch (java.sql.SQLException ex) {
			ex.printStackTrace();
			throw new javax.ejb.CreateException(
				"Key - " + ((new Integer(policyNo)).toString()) + "  " + ex.toString());
		} catch (javax.ejb.DuplicateKeyException ex) {
			throw ex;
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex.toString());
		}
		//
		// cleanup
		//
		finally {
			try {
				if (pstmt != null)
					pstmt.close();
			} catch (Exception e) {
			}
			try {
				if (conn != null)
					conn.close();
			} catch (Exception e) {
			}
		}
	}
	/**
	 * ejbFindByPrimaryKey method comment
	 * @return com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey
	 * @param primaryKey com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey
	 * @exception java.rmi.RemoteException The exception description.
	 * @exception javax.ejb.FinderException The exception description.
	 */
	public com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey ejbFindByPrimaryKey(
		com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey primaryKey)
		throws javax.ejb.FinderException {
		PreparedStatement pstmt = null;
		Connection conn = null;
		try {
			policyNo = primaryKey.policyNo;
			//
			// go to data base and get the data
			//
			conn = getConnection();
			pstmt =
				conn.prepareStatement("select PNUMBER from BBO.POLICYDO where PNUMBER = ?");
			pstmt.setInt(1, policyNo);
			ResultSet rs = pstmt.executeQuery();
			//
			// exists?   return the primary key
			//
			if (rs.next()) {
				return primaryKey;
			}
			//
			// nope, doesn't exist, return exception. 
			else {
				throw new javax.ejb.ObjectNotFoundException(
					"Key - " + ((new Integer(policyNo)).toString()));
			}

		} catch (java.sql.SQLException ex) {
			ex.printStackTrace();
			throw new javax.ejb.FinderException(
				"Key - " + ((new Integer(policyNo)).toString()) + "  " + ex.toString());
		} catch (javax.ejb.ObjectNotFoundException ex) {
			throw ex;
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new EJBException(ex.toString());
		}
		//
		// cleanup
		//
		finally {
			try {
				if (pstmt != null)
					pstmt.close();
			} catch (Exception e) {
			}
			try {
				if (conn != null)
					conn.close();
			} catch (Exception e) {
			}
		}
	}
	/**
	 * ejbLoad method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbLoad() throws java.rmi.RemoteException {
		PolicyBMPKey pkey = (PolicyBMPKey) entityContext.getPrimaryKey();
		policyNo = pkey.policyNo;
		PreparedStatement pstmt = null;
		Connection conn = null;
		try {
			//
			// go to the database and get the data
			//
			conn = getConnection();
			pstmt = conn.prepareStatement("select * from BBO.POLICYDO where PNUMBER = ?");
			pstmt.setInt(1, policyNo);
			ResultSet rs = pstmt.executeQuery();
			//
			// record exists, load the bean fields
			if (rs.next()) {
				premium = rs.getFloat("PPREMIUM");
				amount = rs.getFloat("PAMOUNT");
			}
			//
			// doesn't exist, must be a problem.  It was just created or found.
			//
			else {
				throw new RemoteException(
					"PolicyNO failed to load from database.  Key - "
						+ ((new Integer(policyNo)).toString()));
			}
		} catch (RemoteException ex) {
			throw ex;
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new RemoteException(
				"PolicyNO failed to load from database.  Key - "
					+ ((new Integer(policyNo)).toString())
					+ "  "
					+ ex.toString());
		}
		//
		// cleanup
		//
		finally {
			try {
				if (pstmt != null)
					pstmt.close();
			} catch (Exception e) {
			}
			try {
				if (conn != null)
					conn.close();
			} catch (Exception e) {
			}
		}
	}
	/**
	 * ejbPassivate method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbPassivate() throws java.rmi.RemoteException {
	}
	/**
	 * ejbPostCreate method for a BMP entity bean
	 * @param int policyNo 
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbPostCreate(int policyNo) {
	}
	/**
	 * ejbPostCreate method for a BMP entity bean
	 * @param key com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbPostCreate(com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey key) {
	}
	/**
	 * ejbRemove method comment
	 * @exception java.rmi.RemoteException The exception description.
	 * @exception javax.ejb.RemoveException The exception description.
	 */
	public void ejbRemove()
		throws java.rmi.RemoteException, javax.ejb.RemoveException {
		PolicyBMPKey pkey = (PolicyBMPKey) entityContext.getPrimaryKey();
		int pNo = pkey.policyNo;
		PreparedStatement pstmt = null;
		Connection conn = null;
		//
		// delete record from database with this key.
		try {
			conn = getConnection();
			pstmt = conn.prepareStatement("delete from BBO.POLICYDO where PNUMBER = ?");
			pstmt.setInt(1, pNo);
			//
			// no record deleted, throw and exception
			//
			if (pstmt.executeUpdate() == 0) {
				throw new javax.ejb.RemoveException(
					"PolicyNO failed to remove from database.  Key - "
						+ ((new Integer(policyNo)).toString()));
			}
		} catch (javax.ejb.RemoveException ex) {
			throw ex;
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new javax.ejb.RemoveException(
				"PolicyNO failed to remove from database.  Key - "
					+ ((new Integer(policyNo)).toString())
					+ "  "
					+ ex.toString());
		}
		//
		// cleanup
		//
		finally {
			try {
				if (pstmt != null)
					pstmt.close();
			} catch (Exception e) {
			}
			try {
				if (conn != null)
					conn.close();
			} catch (Exception e) {
			}
		}
	}
	/**
	 * ejbStore method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbStore() throws java.rmi.RemoteException {
		PolicyBMPKey pkey = (PolicyBMPKey) entityContext.getPrimaryKey();
		PreparedStatement pstmt = null;
		Connection conn = null;
		try {
			//
			// update record in the database.
			//
			conn = getConnection();
			pstmt =
				conn.prepareStatement(
					"update BBO.POLICYDO set PAMOUNT = ?, PPREMIUM = ? where PNUMBER = ?");
			pstmt.setDouble(1, amount);
			pstmt.setDouble(2, premium);
			pstmt.setInt(3, policyNo);
			pstmt.executeUpdate();
		}
		//
		// something happened.
		//	
		catch (Exception ex) {
			ex.printStackTrace();
			throw new java.rmi.RemoteException(
				"PolicyNO failed to store in database.  Key - "
					+ ((new Integer(policyNo)).toString())
					+ "  "
					+ ex.toString());
		}
		//
		// cleanup
		//
		finally {
			try {
				if (pstmt != null)
					pstmt.close();
			} catch (Exception e) {
			}
			try {
				if (conn != null)
					conn.close();
			} catch (Exception e) {
			}
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 10:14:37 PM)
	 * @return double
	 */
	public double getAmount() {
		return amount;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 10:04:24 PM)
	 * @return java.sql.Connection
	 * @exception java.sql.SQLException The exception description.
	 */
	public java.sql.Connection getConnection()
		throws java.sql.SQLException, javax.naming.NamingException {
		InitialContext ctx = null;
		//
		// get a jdbc connection
		// 
		try {
			if (ds == null) {
				ctx = new InitialContext();
				try {
					ds = (javax.sql.DataSource) ctx.lookup("java:comp/env/jdbc/policy");
				}
				//
				// just in case we're testing in the VAJ environment with ejb 1.0's
				//
				catch (javax.naming.NameNotFoundException ex) {
					ds = (javax.sql.DataSource) ctx.lookup("jdbc/policy");
				}
				//	 		ds = new com.ibm.db2.jcc.DB2DataSource();		 	}
			}
			conn = ds.getConnection();
		} catch (java.sql.SQLException ex) {
			ex.printStackTrace();
			throw ex;
		} catch (javax.naming.NamingException ex) {
			ex.printStackTrace();
			throw ex;
		}
		return conn;
	}
	/**
	 * getEntityContext method comment
	 * @return javax.ejb.EntityContext
	 */
	public javax.ejb.EntityContext getEntityContext() {
		return entityContext;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 10:15:56 PM)
	 * @return int
	 */
	public int getPolicyNo() {
		return policyNo;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 10:14:37 PM)
	 * @return double
	 */
	public double getPremium() {
		return premium;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 10:14:37 PM)
	 * @param newAmount double
	 */
	public void setAmount(double newAmount) {
		amount = newAmount;
	}
	/**
	 * setEntityContext method comment
	 * @param ctx javax.ejb.EntityContext
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void setEntityContext(javax.ejb.EntityContext ctx)
		throws java.rmi.RemoteException {
		entityContext = ctx;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 10:14:37 PM)
	 * @param newPremium double
	 */
	public void setPremium(double newPremium) {
		premium = newPremium;
	}
	/**
	 * unsetEntityContext method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void unsetEntityContext() throws java.rmi.RemoteException {
		entityContext = null;
	}
}