package com.ibm.ws390.samples.ivp.client;

import java.io.*;
/**
 * Insert the type's description here.
 * Creation date: (12/15/2000 9:28:14 PM)
 * @author: Administrator
 */
import javax.naming.InitialContext;
import com.ibm.ws390.samples.ivp.ejb.PolicySessionHome;   
import com.ibm.ws390.samples.ivp.ejb.PolicySession;
public class TestClient {

	public final static String JNDI_SESSION_NAME = "ivp.policysession";
	public final static String WAS_INITIAL_CONTEXT_FACTORY = "com.ibm.ws.naming.ldap.WsnLdapInitialContextFactory";
	//public final static String PROVIDER_URL = "PROVIDER_URL";
	//public final static String INITIAL_CONTEXT_FACTORY="INITIAL_CONTEXT_FACTORY";
/**
 * TestClient constructor comment.
 */
public TestClient() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (12/15/2000 9:29:13 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	PolicySessionHome home= null; 
	PolicySession policySession = null;
	InitialContext ctx=null;
	int policyNo1 = 0;
	int policyNo2 = 0;
	String beanType = null;
	//
	// look for command line arguments cmp or bmp.
	//
	if (args.length < 1) {
		System.out.println("Either cmp or bmp must be specified as an argument on the command line!");
		System.exit(1);
	}
	else if (args.length > 1) {
		System.out.print("Only bmp or cmp can be specified on the command line! Found: ");
		for (int i=0; i < args.length; i++) {
			System.out.print(args[i]+" ");
		}
		System.out.print(" \n");
		System.exit(1);
	}
	else if (args[0].equals("bmp")) {
		System.out.println("***********  bmp bean will be run!");
		policyNo1=1111;
		policyNo2=7777;		
	}
	else if (args[0].equals("cmp")) {
		System.out.println("***********  cmp bean will be run!");
		policyNo1=2222;
		policyNo2=8888; 
	}
	else {
		System.out.println("Specify either bmp or cmp on command line, found: "+args[0]);
		System.exit(1);
	}			
	System.out.println("Look up policy session home");
	//
	// Do initial home lookup
	//
	try {
		System.out.println("Obtaining policysession bean jndi name...");
  		java.util.Properties p = System.getProperties();
		String homeName = p.getProperty("SESSION_NAME");

		java.util.Properties prop = new java.util.Properties();
	
		System.out.println("The policysession bean jndi name is: " + homeName);
 
		if (homeName == null) {
			System.out.println("Must specify -DSESSION_NAME=policy_session_home_name");
			System.exit(1);
		} 

		prop.setProperty(javax.naming.Context.INITIAL_CONTEXT_FACTORY,WAS_INITIAL_CONTEXT_FACTORY);

		//
		// Create initial context...
		//
 	
		ctx = new InitialContext(prop);

		//
		// Do initial home lookup
		//
		
		System.out.println("Lookup policy session home");
		java.lang.Object objHome = ctx.lookup(homeName);
		System.out.println("homeName: " + homeName);
		System.out.println("Narrow policy session home");
		home= ((PolicySessionHome) (javax.rmi.PortableRemoteObject.narrow(objHome,PolicySessionHome.class)));
		System.out.println("Driving policy session bean");
		policySession=home.create();
		//
		// Create two policy beans using the session, set a premium and an amount.
		//
		 
		policySession.tran1(args[0],policyNo1,policyNo2); 
	 	//
		// Add 88 to the premium for policy number 2
		//
		policySession=home.create();
		policySession.tran2(args[0],policyNo2);
		System.out.println(args[0]+" IVP has completed successfully");
		
	}
	catch (Exception ex) {
		System.out.println("IVP has failed");
		ex.printStackTrace();
		System.exit(1);
	}
}
}
