package proxy.soap.com.ibm.ws390.samples.ivp.ejb;

import java.net.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.soap.*;
import org.apache.soap.encoding.*;
import org.apache.soap.encoding.soapenc.*;
import org.apache.soap.rpc.*;
import org.apache.soap.util.xml.*;

public class PolicySessionProxy
{
  private Call call = new Call();
  private URL url = null;
  private String stringURL = "http://localhost:8080/PolicyIVP/servlet/rpcrouter";
  private SOAPMappingRegistry smr = call.getSOAPMappingRegistry();

  public PolicySessionProxy()
  {
  }

  public synchronized void setEndPoint(URL url)
  {
    this.url = url;
  }

  public synchronized URL getEndPoint() throws MalformedURLException
  {
    return getURL();
  }

  private URL getURL() throws MalformedURLException
  {
    if (url == null && stringURL != null && stringURL.length() > 0)
    {
      url = new URL(stringURL);
    }
    return url;
  }

  public synchronized void tran1(java.lang.String beanType,int policyNo1,int policyNo2) throws Exception
  {
    String targetObjectURI = "http://tempuri.org/com.ibm.ws390.samples.ivp.ejb.PolicySession";
    String SOAPActionURI = "";

    if(getURL() == null)
    {
      throw new SOAPException(Constants.FAULT_CODE_CLIENT,
      "A URL must be specified via PolicySessionProxy.setEndPoint(URL).");
    }

    call.setMethodName("tran1");
    call.setEncodingStyleURI(Constants.NS_URI_SOAP_ENC);
    call.setTargetObjectURI(targetObjectURI);
    Vector params = new Vector();
    Parameter beanTypeParam = new Parameter("beanType", java.lang.String.class, beanType, Constants.NS_URI_SOAP_ENC);
    params.addElement(beanTypeParam);
    Parameter policyNo1Param = new Parameter("policyNo1", int.class, new Integer(policyNo1), Constants.NS_URI_SOAP_ENC);
    params.addElement(policyNo1Param);
    Parameter policyNo2Param = new Parameter("policyNo2", int.class, new Integer(policyNo2), Constants.NS_URI_SOAP_ENC);
    params.addElement(policyNo2Param);
    call.setParams(params);
    Response resp = call.invoke(getURL(), SOAPActionURI);

    //Check the response.
    if (resp.generatedFault())
    {
      Fault fault = resp.getFault();
      call.setFullTargetObjectURI(targetObjectURI);
      throw new SOAPException(fault.getFaultCode(), fault.getFaultString());
    }

  }

}
