package com.ibm.ws390.samples.ivp.ejb;

import java.rmi.RemoteException;
import java.security.Identity;
import java.util.Properties;
import javax.ejb.*;
import javax.naming.InitialContext;
/**
 * This is a Session Bean Class
 */
public class PolicySessionBean implements SessionBean {
	private javax.ejb.SessionContext mySessionCtx = null;
	final static long serialVersionUID = 3206093459760846163L;

	/**
	 * ejbActivate method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbActivate() throws java.rmi.RemoteException {
	}
	/**
	 * ejbCreate method comment
	 * @exception javax.ejb.CreateException The exception description.
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbCreate() throws javax.ejb.CreateException {
	}
	/**
	 * ejbPassivate method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbPassivate() throws java.rmi.RemoteException {
	}
	/**
	 * ejbRemove method comment
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void ejbRemove() throws java.rmi.RemoteException {
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 8:43:35 PM)
	 * @param beanType java.lang.String
	 * @param policyNo1 int
	 * @param policyNo2 int
	 */
	public void finderForIVP(int policyNo, double limit)
		throws java.rmi.RemoteException {

		InitialContext ctx = null;
		java.lang.Object objHome;
		//
		// Do initial home lookup
		//
		System.out.println("Starting finderForIVP");
		System.out.println("Get an initial context");
		try {
			//
			// Get the initial context.
			//
			ctx = new InitialContext();
			//
			// find cmp home
			//
			com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome home = null;
			com.ibm.ws390.samples.ivp.ejb.PolicyCMP policyBean = null;
			System.out.println("Lookup policy home");
			try {
				objHome = ctx.lookup("java:comp/ejb/ivp/policycmp");
			}
			//
			// just in case we're testing in the VAJ environment with ejb 1.0's
			//
			catch (javax.naming.NameNotFoundException ex) {
				objHome = ctx.lookup("ivp/policycmp");
			}
			//
			// narrow to a cmp home
			//
			System.out.println("Narrow home");
			home =
				((com
					.ibm
					.ws390
					.samples
					.ivp
					.ejb
					.PolicyCMPHome) (javax
					.rmi
					.PortableRemoteObject
					.narrow(objHome, com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome.class)));
			System.out.println("Issuing multi-object finder");
			//
			// find all policy beans that are greater than the limit passed as a parameter
			//		
			java.util.Enumeration pbEnumerator = home.findPremiumGreaterThan(limit);
			//
			// convert limit to a string for later use in messages.
			//
			String stringLimit = (new Double(limit)).toString();
			//
			// loop through the policy beans returned in the enumerator.
			//
			while (pbEnumerator.hasMoreElements()) {
				policyBean =
					(com.ibm.ws390.samples.ivp.ejb.PolicyCMP) pbEnumerator.nextElement();
				int pNo = policyBean.getPolicyNo();
				System.out.println(
					"Bean - " + ((new Long(pNo)).toString()) + " has value " + stringLimit);
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new RemoteException(ex.toString());
		}
	}
	/**
	 * getSessionContext method comment
	 * @return javax.ejb.SessionContext
	 */
	public javax.ejb.SessionContext getSessionContext() {
		return mySessionCtx;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/8/2001 1:30:21 PM)
	 */
	public void ping() {
	}
	/**
	 * setSessionContext method comment
	 * @param ctx javax.ejb.SessionContext
	 * @exception java.rmi.RemoteException The exception description.
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx)
		throws java.rmi.RemoteException {
		mySessionCtx = ctx;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 8:43:35 PM)
	 * @param beanType java.lang.String
	 * @param policyNo1 int
	 * @param policyNo2 int
	 */
	public void tran1(String beanType, int policyNo1, int policyNo2)
		throws java.rmi.RemoteException {

		InitialContext ctx = null;
		java.lang.Object objHome;
		//
		// Do initial home lookup
		//
		System.out.println("Starting Tran1");
		System.out.println("Obtaining an initial context");
		try {
			//
			// Get the initial context.
			//
			ctx = new InitialContext();
			//
			// try bmp
			//
			if (beanType.equals("bmp")) {
				System.out.println("Running a bmp bean");
				com.ibm.ws390.samples.ivp.ejb.PolicyBMPHome home = null;
				com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey key1 = null, key2 = null;
				com.ibm.ws390.samples.ivp.ejb.PolicyBMP policyBean1 = null, policyBean2 = null;
				System.out.println("Lookup bmp policy home");
				try {
					objHome = ctx.lookup("java:comp/env/ejb/ivp/policybmp");
				}
				//
				// just in case we're testing in the VAJ environment with ejb 1.0's
				//
				catch (javax.naming.NameNotFoundException ex) {
					System.out.println("Failed with java:comp lookup. Using alternative lookup...");
					objHome = ctx.lookup("ivp.policybmp");
				}
				System.out.println("Narrow bmp home");
				home =
					((com
						.ibm
						.ws390
						.samples
						.ivp
						.ejb
						.PolicyBMPHome) (javax
						.rmi
						.PortableRemoteObject
						.narrow(objHome, com.ibm.ws390.samples.ivp.ejb.PolicyBMPHome.class)));
				//
				// Bean1
				//
				System.out.println("Finding bean1 - " + ((new Long(policyNo1)).toString()));
				key1 = new com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey(policyNo1);
				try {
					policyBean1 = home.findByPrimaryKey(key1);
				} catch (javax.ejb.ObjectNotFoundException e) {
					try {
						System.out.println("Bean1 does not already exist, creating bean1");
						policyBean1 = home.create(policyNo1);
					} catch (Exception ex) {
						ex.printStackTrace();
						throw new RemoteException(ex.toString());
					}
				} catch (Exception ex) {
					ex.printStackTrace();
					throw new RemoteException(ex.toString());
				}
				//
				// Bean2
				//
				System.out.println("Finding bean2 - " + ((new Long(policyNo2)).toString()));
				key2 = new com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey(policyNo2);
				try {
					policyBean2 = home.findByPrimaryKey(key2);
				} catch (javax.ejb.ObjectNotFoundException e) {
					try {
						System.out.println("Bean2 does not already exist, creating bean2");
						policyBean2 = home.create(policyNo2);
					} catch (Exception ex) {
						ex.printStackTrace();
						throw new RemoteException(ex.toString());
					}

				} catch (Exception ex) {
					ex.printStackTrace();
					throw new RemoteException(ex.toString());
				}
				//
				// Check to see that we can access methods on the beans
				//		
				System.out.println("Adding 11 to the amount for both beans ");
				policyBean1.setAmount(policyBean1.getAmount() + 11);
				policyBean2.setAmount(policyBean2.getAmount() + 11);
				System.out.println("Setting premium for bean1 to 150");
				policyBean1.setPremium(150);
				System.out.println("Setting premium for bean2 to 300");
				policyBean2.setPremium(300);
			}
			//
			// try cmp
			//
			else
				if (beanType.equals("cmp")) {
					System.out.println("Running a cmp bean");
					com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome home = null;
					com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey key1 = null, key2 = null;
					com.ibm.ws390.samples.ivp.ejb.PolicyCMP policyBean1 = null, policyBean2 = null;
					System.out.println("Lookup policy cmp home");
					try {
						objHome = ctx.lookup("java:comp/env/ejb/ivp/policycmp");

					}
					//
					// just in case we're testing in the VAJ environment with ejb 1.0's
					//
					catch (javax.naming.NameNotFoundException ex) {
						System.out.println("Failed with java:comp lookup. Using alternative lookup..");
						objHome = ctx.lookup("ivp.policycmp");
					}
					System.out.println("Narrow cmp home");
					home =
						((com
							.ibm
							.ws390
							.samples
							.ivp
							.ejb
							.PolicyCMPHome) (javax
							.rmi
							.PortableRemoteObject
							.narrow(objHome, com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome.class)));
					//
					// Bean1 
					//
					System.out.println("Finding bean1 - " + ((new Long(policyNo1)).toString()));
					key1 = new com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey(policyNo1);
					try {
						policyBean1 = home.findByPrimaryKey(key1);
					} catch (javax.ejb.ObjectNotFoundException e) {
						try {
							System.out.println("Bean1 does not already exist, creating bean1");
							System.out.println("Creating bean");
							policyBean1 = home.create(policyNo1);
						} catch (Exception ex) {
							ex.printStackTrace();
							throw new RemoteException(ex.toString());
						}
					} catch (Exception ex) {
						ex.printStackTrace();
						throw new RemoteException(ex.toString());
					}

					//
					// Bean2
					//
					System.out.println("Finding bean2 - " + ((new Long(policyNo2)).toString()));
					key2 = new com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey(policyNo2);
					try {
						policyBean2 = home.findByPrimaryKey(key2);
					} catch (javax.ejb.ObjectNotFoundException e) {
						try {
							System.out.println("Bean2 does not already exist, creating bean2");
							policyBean2 = home.create(policyNo2);
						} catch (Exception ex) {
							ex.printStackTrace();
							throw new RemoteException(ex.toString());
						}
					} catch (Exception ex) {
						ex.printStackTrace();
						throw new RemoteException(ex.toString());
					}
					//
					// Check to see that we can access methods on the beans
					//		
					System.out.println("Adding 33 to the amount for both beans ");
					policyBean1.setPamount(policyBean1.getPamount() + 33);
					policyBean2.setPamount(policyBean2.getPamount() + 33);
					System.out.println("Setting premium for bean1 to 375");
					policyBean1.setPpremium(375);
					System.out.println("Setting premium for bean2 to 450");
					policyBean2.setPpremium(450);
				}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new RemoteException(ex.toString());
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 8:55:58 PM)
	 * @param beanType java.lang.String
	 * @param policyNo int
	 */
	public void tran2(String beanType, int policyNo)
		throws java.rmi.RemoteException {
		InitialContext ctx = null;
		java.lang.Object objHome;
		//
		// Do initial home lookup
		//
		System.out.println("Starting Tran2");
		System.out.println("Obtaining an initial context");
		try {

			ctx = new InitialContext();
			//
			// try bmp
			// 
			if (beanType.equals("bmp")) {
				com.ibm.ws390.samples.ivp.ejb.PolicyBMPHome home = null;
				com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey key = null;
				com.ibm.ws390.samples.ivp.ejb.PolicyBMP policyBean = null;
				System.out.println("Lookup bmp policy home");
				try {
					objHome = ctx.lookup("java:comp/env/ejb/ivp/policybmp");
				}
				//
				// just in case we're testing in the VAJ environment with ejb 1.0's
				//
				catch (javax.naming.NameNotFoundException ex) {
					System.out.println("Failed with java:comp lookup. Using alternative lookup...");
					objHome = ctx.lookup("ivp.policybmp");
				}
				System.out.println("Narrow bmp home");
				home =
					((com
						.ibm
						.ws390
						.samples
						.ivp
						.ejb
						.PolicyBMPHome) (javax
						.rmi
						.PortableRemoteObject
						.narrow(objHome, com.ibm.ws390.samples.ivp.ejb.PolicyBMPHome.class)));
				//
				// Bean 
				//	
				System.out.println(
					"Find the bean with key - " + ((new Long(policyNo)).toString()));
				key = new com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey(policyNo);
				//
				// should already exist, don't create if bean isn't found. 
				try {
					policyBean = home.findByPrimaryKey(key);
				} catch (ObjectNotFoundException ex) {
					System.out.println(
						"Bean with key: " + key + " Should have already existed. But still not found!");
					ex.printStackTrace();
					throw new RemoteException(ex.toString());
				}
				//
				// add 88 to the premium for the bean.
				//
				System.out.println("Add 88 to premium for Bean ");
				policyBean.setPremium(policyBean.getPremium() + 88);
				System.out.println(
					"New premium for Bean is " + ((new Float(policyBean.getPremium()).toString())));
			}
			//
			// try cmp
			//
			else
				if (beanType.equals("cmp")) {
					com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome home = null;
					com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey key = null;
					com.ibm.ws390.samples.ivp.ejb.PolicyCMP policyBean = null;
					try {
						objHome = ctx.lookup("java:comp/env/ejb/ivp/policycmp");
					}
					//
					// just in case we're testing in the VAJ environment with ejb 1.0's
					//
					catch (javax.naming.NameNotFoundException ex) {
						System.out.println("Failed with java:comp lookup. Using alternative lookup...");
						objHome = ctx.lookup("ivp.policycmp");
					}
					System.out.println("Narrow cmp home");
					home =
						((com
							.ibm
							.ws390
							.samples
							.ivp
							.ejb
							.PolicyCMPHome) (javax
							.rmi
							.PortableRemoteObject
							.narrow(objHome, com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome.class)));
					//
					// Bean 
					//	
					System.out.println(
						"Find the bean with key - " + ((new Long(policyNo)).toString()));
					key = new com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey(policyNo);
					//
					// should already exist, don't create if bean isn't found. 
					try {
						policyBean = home.findByPrimaryKey(key);
					} catch (ObjectNotFoundException ex) {
						System.out.println(
							"Bean with key: " + key + " should have already existed. But still not found!");
						ex.printStackTrace();
						throw new RemoteException(ex.toString());
					}
					//
					// add 88 to the premium for the bean.
					//
					System.out.println("Add 88 to premium for Bean ");
					policyBean.setPpremium(policyBean.getPpremium() + 176);
					System.out.println(
						"New premium for Bean is "
							+ ((new Float(policyBean.getPpremium()).toString())));
				}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new RemoteException(ex.toString());
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (12/15/2000 8:43:35 PM)
	 * @param beanType java.lang.String
	 * @param policyNo1 int
	 * @param policyNo2 int
	 */
	public void verifyIVP(String beanType, int policyNo1, int policyNo2)
		throws
			java.rmi.RemoteException,
			com.ibm.ws390.samples.ivp.utilities.IVPVerificationException {

		InitialContext ctx = null;
		java.lang.Object objHome;
		System.out.println("Look up policy home");
		//
		// Do initial home lookup
		//
		System.out.println("Starting Tran3");
		System.out.println("Get an initial context");
		try {
			//
			// Get the initial context.
			//
			ctx = new InitialContext();
			//
			// try bmp
			//
			if (beanType.equals("bmp")) {
				System.out.println("Running a bmp bean");
				com.ibm.ws390.samples.ivp.ejb.PolicyBMPHome home = null;
				com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey key1 = null, key2 = null;
				com.ibm.ws390.samples.ivp.ejb.PolicyBMP policyBean1 = null, policyBean2 = null;
				System.out.println("Lookup policy home");
				try {
					objHome = ctx.lookup("java:comp/ejb/ivp/policybmp");
				}
				//
				// just in case we're testing in the VAJ environment with ejb 1.0's
				//
				catch (javax.naming.NameNotFoundException ex) {
					objHome = ctx.lookup("ivp/policybmp");
				}
				System.out.println("Narrow home");
				home =
					((com
						.ibm
						.ws390
						.samples
						.ivp
						.ejb
						.PolicyBMPHome) (javax
						.rmi
						.PortableRemoteObject
						.narrow(objHome, com.ibm.ws390.samples.ivp.ejb.PolicyBMPHome.class)));
				//
				// Bean1
				//
				System.out.println("Finding bean1 - " + ((new Long(policyNo1)).toString()));
				key1 = new com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey(policyNo1);
				policyBean1 = home.findByPrimaryKey(key1);
				System.out.println("Finding bean2 - " + ((new Long(policyNo2)).toString()));
				key2 = new com.ibm.ws390.samples.ivp.ejb.PolicyBMPKey(policyNo2);
				policyBean2 = home.findByPrimaryKey(key2);
			}
			//
			// try cmp
			//
			else
				if (beanType.equals("cmp")) {
					System.out.println("Running a cmp bean");
					com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome home = null;
					com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey key1 = null, key2 = null;
					com.ibm.ws390.samples.ivp.ejb.PolicyCMP policyBean1 = null, policyBean2 = null;
					System.out.println("Lookup policy home");
					try {
						objHome = ctx.lookup("java:comp/ejb/ivp/policycmp");
					}
					//
					// just in case we're testing in the VAJ environment with ejb 1.0's
					//
					catch (javax.naming.NameNotFoundException ex) {
						objHome = ctx.lookup("ivp/policycmp");
					}
					System.out.println("Narrow home");
					home =
						((com
							.ibm
							.ws390
							.samples
							.ivp
							.ejb
							.PolicyCMPHome) (javax
							.rmi
							.PortableRemoteObject
							.narrow(objHome, com.ibm.ws390.samples.ivp.ejb.PolicyCMPHome.class)));
					//
					// Bean1 
					//
					System.out.println("Finding bean1 - " + ((new Long(policyNo1)).toString()));
					key1 = new com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey(policyNo1);
					policyBean1 = home.findByPrimaryKey(key1);
					//
					// Bean2
					//
					System.out.println("Finding bean2 - " + ((new Long(policyNo2)).toString()));
					key2 = new com.ibm.ws390.samples.ivp.ejb.PolicyCMPKey(policyNo2);
					policyBean2 = home.findByPrimaryKey(key2);
				}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw new com.ibm.ws390.samples.ivp.utilities.IVPVerificationException(
				ex.toString());
		}
	}
}